--add_delete_load_save_gui.lua   <<this file



------------------
--Quick Reference:
------------------
--1) Basic format of g_retrieved_xml object:
--------------------------------------------
--g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[].tags[].plugs[].plug_path.value


--decalre fx pages[] node
--local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages


--viewbuilder globals
---------------------
my_vb2_dialog = nil
vb2 = nil
--for un-added dialog
my_vb3_dialog = nil
vb3 = nil

--for view all
my_vb4_dialog = nil
vb4 = nil



------------------------------
function load_and_save_gui(vb)--pass in vb (main gui object reference)
------------------------------

  --GUI HOUSEKEEPING
  --toggle dialog so if its already open then close it.  
  if (my_vb2_dialog and my_vb2_dialog.visible) then 
    my_vb2_dialog:close()
    my_vb2_dialog = nil
    vb2 = nil
    return
  end
  
  --[[
  ------------------------------------------
  local function get_all_tag_names(page_idx)
  ------------------------------------------
    local tag_names_table = {}
    local page = "page"..page_idx
    
    --loop
    for tag = 1,#g_retrieved_xml[page].tag_names do 
      tag_names_table[tag] = tostring(g_retrieved_xml[page].tag_names[tag]) --use tostring as we are reading string objects
    end
    return tag_names_table
  end
  --]]
  
  --update the 'main()' gui so that page2 (user 1) is selected
  --(Native page1 can not be modified with 'this' gui)
  --------------------------------------------
  local function choose_page_in_main_gui(page)
  --------------------------------------------
    --set global page variable to chosen page
    g_selected_page = page
    
    --fx pages[] node
    local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages
    
    if page == 2 then
      --update page button colors
      vb.views["page1"].color = COLOR_GREY
      vb.views["page2"].color = COLOR_YELLOW_MILD
      vb.views["page3"].color = COLOR_GREY
      
      --update tag buttons and popup
      for button = 1,12 do
        --get each tag names for page 1 from the xml 
        local tag =  tostring(xml_page[2].tags[button].name)
       -- local tag = tostring(g_retrieved_xml.page2.tag_names[button])
        vb.views["tag "..tostring(button)].text = tag
      end
    elseif page == 3 then
      g_selected_page = 3
      --update page button colors
      vb.views["page1"].color = COLOR_GREY
      vb.views["page2"].color = COLOR_GREY
      vb.views["page3"].color = COLOR_YELLOW_MILD
      
                
      --update tag buttons and popup
      for button = 1,12 do
        --get each tag names for page 1 from the xml
        local tag =  tostring(xml_page[3].tags[button].name)
       --local tag = tostring(g_retrieved_xml.page3.tag_names[button])
          vb.views["tag "..tostring(button)].text = tag
        end
      end
    end
   -------------------------------------------
   --run
   if g_selected_page == 1 then
     choose_page_in_main_gui(2)  
   end
  
  
  
  --Build 'this GUI'
  ------------------
  --make a new viewbuilder instance vb2 (vb is the main gui)
  vb2 = renoise.ViewBuilder()
  
  local BUTTON_WIDTH = 150
  local BUTTON_HEIGHT = 30
  
  
   --build dialog content
  local dialog_content = vb2:column{
                          margin = 4,
                          vb2:row{
                            vb2:text{
                              text = "                                                          "--spacer
                            },
                            vb2:button{
                             text = "USER 1",
                             width = 25,
                             height = 22,
                             id = "vb2 button1",
                             color = COLOR_YELLOW_MILD,
                             notifier = function()
                                          --update button colors to show page selection
                                          vb2.views["vb2 button1"].color = COLOR_YELLOW_MILD
                                          vb2.views["vb2 button2"].color = COLOR_GREY
                                          --use above local function to change selection in main gui
                                          choose_page_in_main_gui(2)
                                          --update all textfields
                                          
                                          --make edit page add/delete buttons active in case edit page is open
                                          if vb2 ~= nil then
                                            vb2.views["vb2b1"].active = true
                                            vb2.views["vb2b2"].active = true
                                            vb2.views["vb2b3"].active = true
                                            vb2.views["vb2b4"].active = true
                                            vb2.views["vb2b5"].active = true
                                            vb2.views["vb2b6"].active = true
                                          end
                                          
                                          update_load_popup()
                                        --  local tag_names = get_all_tag_names(2)
                                         -- for i = 1,12 do
                                          --  vb.views["tagedit "..i].text =tostring(tag_names[i])
                                        --  end
                                          
                                        end
                            },
                            vb2:button{
                              text = "USER 2",
                              width = 25,
                              height = 22,
                              id = "vb2 button2",
                              color = COLOR_GREY,
                                notifier = function()
                                          --update button colors to show page selection
                                          vb2.views["vb2 button1"].color = COLOR_GREY 
                                          vb2.views["vb2 button2"].color = COLOR_YELLOW_MILD
                                          --use above local function to change selection in main gui
                                          choose_page_in_main_gui(3)
                                          
                                          --make edit page add/delete buttons active in case edit page is open
                                          if vb2 ~= nil then
                                            vb2.views["vb2b1"].active = true
                                            vb2.views["vb2b2"].active = true
                                            vb2.views["vb2b3"].active = true
                                            vb2.views["vb2b4"].active = true
                                            vb2.views["vb2b5"].active = true
                                            vb2.views["vb2b6"].active = true
                                          end
                                          
                                          update_load_popup()
                                          --update all textfields
                                         -- local tag_names = get_all_tag_names(3)
                                         -- for i = 1,12 do
                                         --   vb.views["tagedit "..i].text =tostring(tag_names[i])
                                         -- end
                                        end
                            },
                          },
                          vb2:text{
                           text = "Add Devices To Tags:",
                           },
                           vb2:text{ 
                           text = "        -----------------------  Current Tag  -----------------------              ------- ALL TAGS -------",
                           },
                          vb2:row{
                            margin = 4,
                            vb2:button{
                             color = COLOR_GREEN_MILD,
                             width = BUTTON_WIDTH,
                             height = BUTTON_HEIGHT,
                             id = "vb2b1",
                             text = "[+] Selected Device",
                             notifier = function()
                                          --check we are on user page, if not return message
                                          if g_selected_page == 1 then
                                            renoise.app():show_message("Can't add tags on NATIVE page.\nOnly user pages")
                                            return
                                          end
                                          local song = renoise.song()
                                          --make sure a device is seleced.  If not return with a dialog warning to user
                                          if song.selected_track_device == nil or song.selected_track_device_index == 1 then
                                             renoise.app():show_error("Device Needs To Be Selected")
                                             return
                                          end
                                          --find in the file: add_and_remove_functions.lua 
                                          add_selected_device_to_selected_tag()
                                          
                                          
                                          --sort the selected tag list alphabetically
                                          sort_tag_list() --this function also updates popup 
                                          --update popup
                                         
                                         
                                          update_load_popup()  
                                          
                                          --choose new item in popup
                                          --------------------------
                                          --get short name
                                          local sel_plug_short_name = strip_out_device_name_from_display_name(song.selected_track_device.name)
                                          --loop and compare popup items to selected plug that was just added
                                          local popup = vb.views["load plug popup"]
                                          for i = 1,#popup.items do
                                            if popup.items[i] == sel_plug_short_name then
                                              popup.value = i
                                              break
                                            end
                                          end
                                        end,
                             },
                             vb2:button{
                             color = COLOR_GREY,
                             width = BUTTON_WIDTH,
                             height = BUTTON_HEIGHT,
                             id = "vb2b2",
                             text = "[+] All Track Devices",
                             notifier = function()
                                          --check we are on user page, if not return message
                                          if g_selected_page == 1 then
                                            renoise.app():show_message("Can't add tags on NATIVE page.\nOnly user pages")
                                            return
                                          end
                                          
                                          --return if no new plugs present
                                          if #renoise.song().selected_track.devices < 2 then
                                            renoise.app():show_message("No Plugs present In Track To Add")
                                            return
                                          end
                                          
                                          
                                          --warn user that plugs will be overwritten in tag
                                          local message = "This operation will overwrite\nall plugs listed in in the current tag\nand can't be undone\ndo you want to continue?"
                                          --check the user definitely wants to delete all tags in page
                                          local confirm = renoise.app():show_prompt("Confirmation Dialog", message, {"Yes","Cancel"})
                                          --cancelled by user:
                                          if confirm == "Cancel" then
                                            return
                                          end
                                          
                                          --find in the file: add_and_remove_functions.lua  
                                          --default is selected track/tag, it also updates popup
                                          add_all_devices_in_track_to_tag() 
                                        end,
                             },
                             vb2:button{
                             color = COLOR_GREY,
                             width = BUTTON_WIDTH,
                             height = BUTTON_HEIGHT,
                             id = "vb2b3",
                             text = "[+] Tracks 1-12",
                             notifier = function()
                                          --check we are on user page, if not return message
                                          if g_selected_page == 1 then
                                            renoise.app():show_message("Can't add tags on NATIVE page.\nOnly user pages")
                                            return
                                          end
                                          
                                          local message = "This operation will overwrite\nall tags in the current page\nand can't be undone\ndo you want to continue?"
                                          --check the user definitely wants to delete all tags in page
                                          local confirm = renoise.app():show_prompt("Confirmation Dialog", message, {"Yes","Cancel"})
                                          --cancelled by user:
                                          if confirm == "Cancel" then
                                            return
                                          end
                                          
                                          --find in the file: add_and_remove_functions.lua  
                                          add_tracks_one_to_twelve_to_selected_page()
                                          --save changes to xml
                                          save_to_xml_file() 
                                          --status
                                          status("Devices Added From Pattern")
                                        end,
                             },
                            },
                           vb2:text{
                            text = "Delete Devices From Tags:",
                           },
                          vb2:row{
                            margin = 4,
                            vb2:button{
                             color = COLOR_GREY,
                             width = BUTTON_WIDTH,
                             height = BUTTON_HEIGHT,
                             id = "vb2b4",
                             text = "[-] Selected Tag Entry",
                             notifier = function()
                                          --globals
                                          local page_idx = g_selected_page
                                          local tag_idx = g_selected_button 
                                          
                                          if page_idx == 1 then
                                            renoise.app():show_message("Can't delete tags on NATIVE page.\nOnly user pages")
                                            return
                                          end
                                          
                                          --get selected item from main gui popup
                                          local item_idx = vb.views["load plug popup"].value
                                          --get selected item from main gui popup
                                          local item_name = vb.views["load plug popup"].items[item_idx]
                                          
                                          if item_name == "None" then
                                            status("No Plugins Left In Tag To Delete")
                                            return
                                          end
                                          ---print(item_name)
                                          
                                          --find fn in the file: add_and_remove_functions.lua  
                                          ---------------------------------------------
                                          remove_entry_from_tab(page_idx,tag_idx,item_idx,item_name)--remove plug name
                                          --save updates
                                          save_to_xml_file()
                                          --update popup
                                          update_load_popup()
                                          --status
                                          status("Device Deleted")
                                        end,
                             },
                             
                            vb2:button{
                             color = COLOR_GREY,
                             width = BUTTON_WIDTH,
                             height = BUTTON_HEIGHT,
                             id = "vb2b5",
                             text = "[-] All In Selected Tag",
                             notifier = function()
                             
                             
                                          --globals
                                          local page_idx = g_selected_page
                                          local button_idx = g_selected_button 
                                          
                                          if page_idx == 1 then
                                            renoise.app():show_message("Can't delete tags on NATIVE page.\nOnly user pages")
                                            return
                                          end
                                          
                                          local message = "This operation will remove\nall plugs from the current tag\nand can't be undone\ndo you want to continue?"
                                          --check the user definitely wants to delete all tags in page
                                          local confirm = renoise.app():show_prompt("Confirmation Dialog", message, {"Yes","Cancel"})

                                          if confirm == "Cancel" then
                                            status("Tag Delete Cancelled")
                                            return
                                          end
                                          
                                          --get fx pages[] node
                                          local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages 
                                          ---------------------------------------------
                                          --delete all current devices saved in the tag
                                          ---------------------------------------------
                                          for i = #xml_page[g_selected_page].tags[g_selected_button].plugs,1,-1 do
                                            --get name from xml object
                                            local name = tostring(xml_page[g_selected_page].tags[g_selected_button].plugs[i].plug_name)
                                            --delete using global function
                                            remove_plugin_node(TYPE_EFFECT,g_selected_page,g_selected_button,name)
                                          end
                                        
                                          --save updates
                                          save_to_xml_file()
                                          --update popup
                                          update_load_popup()
                                          --clear tags name
                                          vb.views["tag "..tostring(button_idx)].text = ""
                                          --status
                                          status("All Items Removed From Tag")
                                        
                                        end,
                             },
                            vb2:button{
                             color = COLOR_GREY,
                             width = BUTTON_WIDTH,
                             height = BUTTON_HEIGHT,
                             id = "vb2b6",
                             text = "[-] All In Selected Page",
                             notifier = function()
                             
                                          local page_idx = g_selected_page
                                          
                                          if page_idx == 1 then
                                            renoise.app():show_message("Can't delete tags on NATIVE page.\nOnly user pages")
                                            return
                                          end
                             
                                          
                                          local message = "This operation will clear\nall tags (and plugs) on the current page\nand can't be undone\ndo you want to continue?"
                                          --check the user definitely wants to delete all tags in page
                                          local confirm = renoise.app():show_prompt("Confirmation Dialog", message, {"Yes","Cancel"})
                                          if confirm == "Cancel" then
                                            status("Page Delete Cancelled")
                                            return
                                          end
                                          
                                          
                                          --get fx pages[] node
                                          local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages 
                                          
                                          for tab_idx = 1,12 do
                                            --update name
                                            xml_page[g_selected_page].tags[tab_idx].name.value = tostring(tab_idx)
                                          
                                            ---------------------------------------------
                                            --delete all current devices saved in the tag
                                            ---------------------------------------------
                                            for i = #xml_page[g_selected_page].tags[tab_idx].plugs,1,-1 do
                                              --get name from xml object
                                              local name = tostring(xml_page[g_selected_page].tags[tab_idx].plugs[i].plug_name)
                                              --delete using global function
                                              remove_plugin_node(TYPE_EFFECT,g_selected_page,tab_idx,name)
                                            end
                                          end
                                          --clear tag names
                                          for tab_idx = 1,12 do
                                            vb.views["tag "..tostring(tab_idx)].text = tostring(tab_idx)
                                          end
                                          --save updates
                                          save_to_xml_file()
                                          --update popup
                                          update_load_popup()
                                          --status
                                          status("All Items Removed From Page")
                                          
                                         --[[
                                          --gets xml list length for chosen tag contents (plug names/paths) 
                                          -------------------------------------------------------
                                          local function get_tag_list_length(page_idx,button_idx)
                                          ------------------------------------------------------
                                            local page_tag = 'page'..page_idx
                                            local tag_idx = 'tag'..button_idx 
                                            return #g_retrieved_xml[page_tag][tag_idx]
                                          end
                                          -----
                                          --]]
                                          --[[
                                          --loop buttons(tags)
                                          for tab_idx = 1,12 do
                                            local last_item = get_tag_list_length(page_idx,tab_idx)
                                            --loop backwards through list of tags (and paths) and delete all entries
                                            for item_idx = last_item,1,-1 do
                                              --find this function in the file: add_and_remove_functions.lua 
                                              remove_entry_from_tab(page_idx,tab_idx,item_idx)
                                            end
                                          end
                                          
                                          --save updates to xml
                                          save_to_xml_file()
                                          --update popup
                                          update_load_popup()
                                          --status
                                          status("All Items Removed From Page ")
                                          --]]
                                        end,
                             },
                            },
                          
                           vb2:text{ 
                            text = "       ",
                           },
                           
                           vb2:text{
                            text = "Import / Export xml:                                                  Info:",
                            },
                            vb2:row{
                             margin = 4,
                             vb2:button{
                             -- active = false,
                              color = COLOR_GREY,
                              width = BUTTON_WIDTH -50,
                              height = BUTTON_HEIGHT -5,
                              text = "Import xml",
                              notifier = function()
                                          --get file name
                                          local file_name = renoise.app():prompt_for_filename_to_read({"*"}, "Load Tag Configuration")
                                          --return if user presses [x]
                                          if file_name == "" then
                                            return
                                          end
                                          
                                          --create object to load file into (same as g_retrieved_xml)
                                          local temp = create_document()
                                          --load file
                                          temp:load_from(file_name)
                                          
                                          
                                          --NOTE NEEDS A PROPER TEST
                                          ---
                                          --test the file
                                          --//////g_retrieved_xml.plugin_types[TYPE_EFFECT].pages[].tags[].plugs[].plug_path.value//////
                                          --test that the first native device entry exists
                                          if temp.plugin_types[TYPE_EFFECT].pages[1].tags[1].plugs[1].plug_path.value ~= "Audio/Effects/Native/Bus Compressor" then
                                            renoise.app():show_message("File Not Recognised As Correct Format")
                                            return
                                          end
                                          --load into global object
                                          g_retrieved_xml = temp
                                          --refresh the gui
                                          gui_refresh_page()
                                          --save
                                          save_to_xml_file()
                                          --status
                                          status("New Tags Imported")
                                        end,
                              },
                             vb2:button{
                            -- active = false,
                              color = COLOR_GREY,
                              width = BUTTON_WIDTH -50,
                              height = BUTTON_HEIGHT -5,
                              text = "Export xml",
                              notifier = function()
                                           local file_path = renoise.app():prompt_for_filename_to_write('.xml', "Save Tag Configuration")
                                           local filename = renoise.tool().bundle_path .. "saved_tags.xml" 
                                           g_retrieved_xml:save_as(file_path)
                                        end,
                              },
                              vb2:text{
                                width = 50, 
                              },
                              vb2:button{
                               color = COLOR_GREY,
                               text = "Un-Added", 
                               notifier = function()
                               
                                          --[favorite_name] =>  Audiocation Phase (mono).x64
                                          --[is_bridged] =>  false
                                          --[is_favorite] =>  false
                                          --[name] =>  Delphi ASIO & VST Project: Audiocation Phase (mono).x64
                                          --[path] =>  Audio/Effects/VST/Audiocation Phase (mono).x64
                                          --[short_name] =>  Audiocation Phase (mono).x64 
                                          
                                          --  xml_page[g_selected_page].tags[g_selected_button].plugs
                                          
                                           --close the dialog if it is already open
                                           if (my_vb3_dialog and my_vb3_dialog.visible) then
                                             my_vb3_dialog:close()
                                             my_vb3_dialog = nil
                                             vb3 = nil
                                             return
                                           end
                                             
                                            
                                           local song = renoise.song()
                                           --table to hold the device names
                                           local un_added_string = ""
                                           --reset viewbuilder
                                           vb3 = nil
                                           
                                          
                                             
                                           --xml page object
                                           local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages
                                                                                                                                     
                                           ----------------------------------
                                           local function plug_present_in_xml(path)
                                           ----------------------------------
                                           
                                           local test_fx_path = path 
                                             --loop pages of xml
                                             for page = 1,g_num_pages do
                                               --tags
                                               local xml_tags = xml_page[page].tags
                                                --loop tags in page
                                                for tag = 1,12 do
                                                  --plugs
                                                  local xml_plugs = xml_tags[tag].plugs
                                                  --loop plugs in tag
                                                  for plug = 1,#xml_plugs do
                                                    --if plug present return false     
                                                    if test_fx_path == xml_plugs[plug].plug_path.value then
                                                      --plug found
                                                      return true
                                                    end
                                                  end
                                                end
                                              end
                                              --plug not found in xml so return false    
                                              return false
                                            end
                                                                                           
                                            --available fx devices
                                            local available_devs = song:track(1).available_device_infos
                                            
                                            
                                            local un_added_items = {}
                                            un_added_items.name = {}
                                            un_added_items.path = {}
                                            
                                            --loop all devices
                                            -------------------
                                            for i = 1,#available_devs do 
                                              --print(is_plug_path_already_present_in_xml(available_devs[i].path))
                                              --local fn above:
                                              if plug_present_in_xml(available_devs[i].path) == false then
                                                --add plug to multiline string, using short_name as we are using plugin infos
                                                un_added_string = un_added_string..available_devs[i].short_name.."\n" --NOTE IF USER HAS CHANGED ANY PLUG DISPLAY NAMES
                                               -- table.insert(un_added_items.name,available_devs[i].short_name)
                                               
                                               
                                               -- table.insert(un_added_items.path,available_devs[i].path)                                            
                                              
                                              
                                              end                                                                     --IN RENOISE, THAT WILL BE THE NAME HERE: short_name
                                            end 
                                            
                                            
                                            
                                              
                                             --assign global vb to viewbuilder
                                             vb3 = renoise.ViewBuilder()
                                             
                                             
                                            -- --make dialpg content
                                            -- local dialog_content =
                                               --[[
                                               
                                               vb3:column{
                                                 margin = 12,
                                                   vb3:popup{
                                                     items = un_added_items.name,
                                                     id = "unaddedpopup",
                                                     width = 300,
                                                     height = 30,
                                                  },
                                                 --]]
                                                 --[[
                                                  vb3:button{
                                                    height = 30,
                                                    width = 150,
                                                    text = "LOAD",
                                                    notifier = function()
                                                       
                                                       local index = vb3.views["unaddedpopup"].value
                                                       local path =  un_added_items.path[index]
                                                       
                                                       ------------------------------
                                                       local function load_device(dev_path)
                                                       ------------------------------
                                                         --song object
                                                         local song = renoise.song()
                                                         --selected track object
                                                         local cur_track = song.selected_track
                                                         --insert pos at selected device or end of devices if none seleced
                                                         local insert_pos = song.selected_track_device_index or #cur_track.devices
                                                         --catch when no devices in track and no selection results in 0
                                                         if insert_pos == 0 then
                                                           insert_pos = #cur_track.devices
                                                         end
                                                         --no checks needed that device exists as it has just been freshly indexed to popup
                                                         --insert device
                                                         local device = cur_track:insert_device_at(path, insert_pos + 1)
                                                         --select device
                                                         song.selected_device_index = (insert_pos + 1)
                                                         --open device gui
                                                         if device.external_editor_available == true then
                                                           device.external_editor_visible = true
                                                         end
                                                       end
                                                        --run 
                                                       load_device(path)
                                                         
                                                         
                                                     
                                                     end,
                                          
                                        
                                                  },--]]
                                                -- },
                                                local dialog_content =
                                                  vb3:column{
                                                   vb3:multiline_textfield { 
                                                    -- id = "unadded",
                                                     width = 310,
                                                     height = 500,
                                                     text = un_added_string,--multi-line string containing plug names
                                                    }, 
                                                   }
                                                  
                                                                   
                                             --   } 
                                                
                                             --Script dialog
                                             my_vb3_dialog = renoise.app():show_custom_dialog(
                                                 "Un Added Plugins", dialog_content)--,my_keyhandler_func)
                                            
                                          end ,
                                          }, 
                                          
                                          vb2:button{
                                           color = COLOR_GREY,
                                           text = "Missing", 
                                           notifier = function()
                                                       --song object
                                                       local song = renoise.song()
                                                       --track for infos[]
                                                       local track = song:track(1)
                                                       --xml page object
                                                       local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages
                                                       
                                                       --returns a table of all paths present in the xml                                                                                         
                                                       -----------------------------------------
                                                       local function get_plugs_present_in_xml()
                                                       -----------------------------------------
                                                         --table will hold all paths of all plugs prestent in the xml
                                                         local tagged_plugs_paths = {}
                                                         --loop pages of xml
                                                         for page = 2,g_num_pages do
                                                           --all tags in page
                                                           local xml_tags = xml_page[page].tags
                                                            --loop tags in page
                                                            for tag = 1,12 do
                                                              --plugs in tag
                                                              local xml_plugs = xml_tags[tag].plugs
                                                              --loop plugs in tag
                                                              for plug = 1,#xml_plugs do
                                                                --add each plug to table   
                                                                table.insert(tagged_plugs_paths,xml_plugs[plug].plug_path.value) 
                                                              end
                                                            end
                                                          end
                                                          return tagged_plugs_paths
                                                        end
                                                        ---
                                                        --run local fn
                                                        local saved_paths = get_plugs_present_in_xml()
                                                        --renoise device infos
                                                        local infos = track.available_device_infos
                                                        --message
                                                        local message = "List Of Missing Or Hidden Devices In Renoise\nThat Are Tagged In The Tool:\n\n"
                                                      
                                                        --loop saved xml paths
                                                        -----------------------
                                                        for i = 1,#saved_paths do
                                                          --stores path and set to nil when a match is found
                                                          local test_path = nil
                                                          --loop all plug infos (all available plugs)
                                                          for j = 1, #infos do
                                                            --set to current path
                                                             test_path = saved_paths[i]
                                                             --compare with present in renoise
                                                             if test_path == infos[j].path then
                                                               --found so set to nil
                                                               test_path = nil
                                                               break
                                                             end
                                                          end
                                                          --When plug path from xml not found in renoise's available paths we add to the output message:
                                                          if test_path ~= nil then
                                                            --strip out the "/" forward slashes from tghe path
                                                            --reverse to make finding last "/" easier
                                                            test_path = test_path:reverse()
                                                            -- string.find(test_path, "/", -#test_path)
                                                            local first_fwd_slash = test_path:find("/")
                                                            test_path = test_path:sub(1 ,first_fwd_slash - 1)--minus 1 as not ot incled the "/"
                                                            
                                                            --flip back the right way
                                                            test_path = test_path:reverse()
                                                            --add to message string
                                                            message = message..test_path.."\n"
                                                          end
                                                        end--loop
                                                        --list all these missing/ hidden devices in a renoise message window
                                                        renoise.app():show_message(message)  
                                                      end,
                                          },
                                          
                                          vb2:button{
                                           color = COLOR_GREY,
                                           text = "Doubled", 
                                           notifier = function()
                                                       
                                                       --close the dialog if it is already open
                                                       if (my_vb4_dialog and my_vb4_dialog.visible) then
                                                         my_vb4_dialog:close()
                                                         my_vb4_dialog = nil
                                                         vb4 = nil
                                                         return
                                                       end
                                                       
                                                       --song object
                                                       local song = renoise.song()
                                                       --xml page object
                                                       local xml_page = g_retrieved_xml.plugin_types[TYPE_EFFECT].pages
                                                       
                                                        --returns a table of all paths present in the xml
                                                       -----------------------------------------
                                                       local function get_plugs_present_in_xml()
                                                       -----------------------------------------
                                                         --table will hold all paths of all plugs prestent in the xml
                                                         local tagged_plugs = {}
                                                         tagged_plugs.name = {}
                                                         tagged_plugs.tag = {}
                                                         --loop pages of xml
                                                         for page = 2,g_num_pages do
                                                           --all tags in page
                                                           local xml_tags = xml_page[page].tags
                                                            --loop tags in page
                                                            for tag = 1,12 do
                                                              --plugs in tag
                                                              local xml_plugs = xml_tags[tag].plugs
                                                              --loop plugs in tag
                                                              for plug = 1,#xml_plugs do
                                                                --add each plug to table   
                                                                table.insert(tagged_plugs.name,xml_plugs[plug].plug_name.value)
                                                                table.insert(tagged_plugs.tag,xml_tags[tag].name.value)
                                                              end
                                                            end
                                                          end
                                                          return tagged_plugs
                                                        end
                                                        ---
                                                        ----------------------------------------------
                                                        local function get_plugs_present_in_xml_once()
                                                        ----------------------------------------------
                                                          --table will hold all paths of all plugs prestent in the xml
                                                          local tagged_plugs = {""}
                                                          tagged_plugs.name = {}
                                                          tagged_plugs.tag = {}
                                                          --loop pages of xml
                                                          for page = 2,g_num_pages do
                                                            --all tags in page
                                                            local xml_tags = xml_page[page].tags
                                                            --loop tags in page
                                                            for tag = 1,12 do
                                                              --plugs in tag
                                                              local xml_plugs = xml_tags[tag].plugs
                                                              --loop plugs in tag
                                                              for plug = 1,#xml_plugs do
                                                                
                                                                local already_present = false
                                                                --loop to check if plug already added
                                                                for i = 1,#tagged_plugs.name do
                                                                  --first entry so add and break
                                                                  if #tagged_plugs.name == 0 then
                                                                    table.insert(tagged_plugs.name,xml_plugs[plug].plug_name.value)
                                                                    table.insert(tagged_plugs.tag,xml_tags[tag].name.value)
                                                                    break
                                                                  end
                                                                  if tagged_plugs.name[i] == xml_plugs[plug].plug_name.value then
                                                                    already_present = true
                                                                    break
                                                                  end
                                                                end
                                                                if already_present == false then
                                                                
                                                                --add each plug to table   
                                                                table.insert(tagged_plugs.name,xml_plugs[plug].plug_name.value)
                                                                table.insert(tagged_plugs.tag,xml_tags[tag].name.value)
                                                               end
                                                              end
                                                            end
                                                          end
                                                          return tagged_plugs
                                                        end
                                                        ---
                                                       
                                                        --full list of plugs in the tags with no doubles
                                                        local tagged_plugs = get_plugs_present_in_xml_once()
                                                        --full list of plugs in the tags including doubles
                                                        local tagged_plugs_2 = get_plugs_present_in_xml()
                                                      
                                                        --string to hold output string that will be displayed in the dialog
                                                        local output_string = "List Of Plugs That Are Present In \nMore Than One Tag\n"
                                                         output_string = output_string.."---------------------------\n\n"                                                        
                                                        --loop through all plug names, using single entries table
                                                        ---------------------------------------------------------
                                                        for i = 1, #tagged_plugs.name do

                                                         -- local this_plug_name = ""
                                                          local this_plugs_tags = {}
                                                          local this_plug_name = tagged_plugs.name[i]
                                                          local matches_found = 0
                                                          --remove last plug from second table
                                                          --table.remove(tagged_plugs_2.name,1)-- #tagged_plugs_2.name)
                                                         -- table.remove(tagged_plugs_2.name,1)-- #tagged_plugs_2.tag)
                                                          
                                                          for j = 1,#tagged_plugs_2.name do
                                                            
                                                            --check if double found then
                                                            if this_plug_name == tagged_plugs_2.name[j] then
                                                              --increment match counter
                                                              matches_found = matches_found + 1
                                                              --store tag where match was found
                                                              table.insert(this_plugs_tags,tagged_plugs_2.tag[j])
                                                            end
                                                          end
                                                          --if more than 1 match found add this plug and its tags
                                                          --to the output string
                                                          if matches_found > 1  then
                                                           -- read tags from table
                                                            local tags = ""
                                                            for i = 1, #this_plugs_tags do
                                                              tags = tags.."-- ".."["..this_plugs_tags[i].."]\n"
                                                            end
                                                            --update output string
                                                            output_string = output_string..this_plug_name.."\n\n"..tags.."\n"
                                                          end
                                                        end                                                                                 
                                                        ---
                                                       
                                                        msg(output_string)
                                                      
                                                      end--notifier
                                           
                                           
                                           },


                           },
                          }


  --Show script dialog
  my_vb2_dialog = renoise.app():show_custom_dialog(
      "Manage Tags", dialog_content)


end
